package org.processmining.models.connections.fuzzymodel;

import org.processmining.framework.connections.annotations.ConnectionObjectFactory;
import org.processmining.framework.connections.impl.AbstractConnection;
import org.processmining.framework.plugin.annotations.Plugin;
import org.processmining.models.graphbased.directed.fuzzymodel.MutableFuzzyGraph;

@Plugin(name = "Fuzzy Model Connection Factory", parameterLabels = { "Fuzzy Model", "Metrics" }, returnTypes = FuzzyModelConnection.class, returnLabels = "Fuzzy Model connection", userAccessible = false)
@ConnectionObjectFactory
public class FuzzyModelConnection extends AbstractConnection {
	public final static String FUZZYMODEL = "FuzzyModel";
	public FuzzyModelConnection(MutableFuzzyGraph fg){
		super("FUZZYMODEL " + fg.getLabel() + "metrics information.");
		put(FUZZYMODEL, fg);
	}
}
